#include<stdio.h>
#include<stdlib.h>
#include "llist.h"

int main(){
	puts("Constructing list manually...");
	NODE *two = construct(5, NULL);
	NODE *one = construct(1, two);
	NODE *root = construct(3, one);
	print_list(root);
	puts("Adding 7 to end...");
	add_to_end(root, 7);
	print_list(root);
	printf("Now it is %d elements long.\n", length(root));
	printf("The head is at %p.\n", root);
	puts("Adding 6 to the beginning and 8 at index 2...");
	insert_node(root, 0, 6);
	insert_node(root, 2, 8);
	print_list(root);
	printf("The head is still at %p.\n", root);
	puts("Searching for 5...");
	NODE_ERR target = search(root, 5);
	printf("I found it at index %d.\n", target.err);
	fputs("The number I found there was: ", stdout);
	print_node(target.node);
	puts("Deleting list...");
	delete_list(root);
	puts("Now it is garbage:");
	print_list(root);

	return 0;
}
